package sun.awt.windows;

import java.awt.Point;
import java.awt.Container;
import java.awt.Event;
import java.awt.MenuContainer;
import sun.awt.SunToolkit;
import java.awt.Component;
import sun.awt.AWTAccessor;
import java.awt.PopupMenu;
import java.awt.peer.PopupMenuPeer;

final class WPopupMenuPeer extends WMenuPeer implements PopupMenuPeer
{
    WPopupMenuPeer(PopupMenu target) {
        this.target = target;
        MenuContainer menuContainer;
        if (AWTAccessor.getPopupMenuAccessor().isTrayIconPopup(target)) {
            menuContainer = AWTAccessor.getMenuComponentAccessor().getParent(target);
        }
        else {
            menuContainer = target.getParent();
        }
        if ((menuContainer instanceof Component)) {
            WComponentPeer wComponentPeer = (WComponentPeer)WToolkit.targetToPeer(menuContainer);
            if (wComponentPeer == null) {
                wComponentPeer = (WComponentPeer)WToolkit.targetToPeer(SunToolkit.getNativeContainer((Component)menuContainer));
            }
            wComponentPeer.addChildPeer(this);
            this.createMenu(wComponentPeer);
            this.checkMenuCreation();
            return;
        }
        else {
            throw new IllegalArgumentException("illegal popup menu container class");
        }
    }
    
    private native void createMenu(WComponentPeer p0);
    
    @Override
    public void show(Event event) {
        Component parent = (Component)event.target;
        if ((WComponentPeer)WToolkit.targetToPeer(parent) == null) {
            Container nativeContainer = SunToolkit.getNativeContainer(parent);
            event.target = nativeContainer;
            for (; parent != nativeContainer; parent = parent.getParent()) {
                Point location = parent.getLocation();
                event.x += location.x;
                event.y += location.y;
            }
        }
        this._show(event);
    }
    
    void show(Component component, Point point) {
        WComponentPeer wComponentPeer = (WComponentPeer)WToolkit.targetToPeer(component);
        Event event = new Event(component, 0L, 501, point.x, point.y, 0, 0);
        if (wComponentPeer == null) {
            event.target = SunToolkit.getNativeContainer(component);
        }
        event.x = point.x;
        event.y = point.y;
        this._show(event);
    }
    
    private native void _show(Event p0);
}
